Loading...
Searching...
No Matches
Opm::Opm::BlackOilOnePhaseIndices< numSolventsV, numExtbosV, numPolymersV, numEnergyV, enableFoam, enableBrine, PVOffset, canonicalCompIdx, numBioCompV > Struct Template Reference

The primary variable and equation indices for the black-oil model. More...

## Static Public Attributes

static constexpr bool | oilEnabled = canonicalCompIdx == 0
| Is phase enabled or not.
static constexpr bool | waterEnabled = canonicalCompIdx == 1
static constexpr bool | gasEnabled = canonicalCompIdx == 2
static constexpr bool | enableSolvent = numSolventsV > 0
| Are solvents involved?
static constexpr bool | enableExtbo = numExtbosV > 0
| Is extbo invoked?
static constexpr bool | enablePolymer = numPolymersV > 0
| Are polymers involved?
static constexpr bool | enableEnergy = numEnergyV > 0
| Shall energy be conserved?
static constexpr bool | enableMICP = numBioCompV == 5
| Is MICP involved? (microbes, oxygen, urea, biofilm, and calcite).
static constexpr bool | enableBiofilm = false
| Biofilm effects on co2/h2store only for two phase indices.
static constexpr int | numSolvents = enableSolvent ? numSolventsV : 0
| Number of solvent components to be considered.
static constexpr int | numExtbos = enableExtbo ? numExtbosV : 0
| Number of components to be considered for extbo.
static constexpr int | numPolymers = enablePolymer ? numPolymersV : 0
| Number of polymer components to be considered.
static constexpr int | numEnergy = enableEnergy ? numEnergyV : 0
| Number of energy equations to be considered.
static constexpr int | numFoam = enableFoam? 1 : 0
| Number of foam equations to be considered.
static constexpr int | numBrine = enableBrine? 1 : 0
| Number of salt equations to be considered.
static constexpr int | numPhases = 1
| The number of fluid phases.
static constexpr int | numMICPs = enableMICP ? numBioCompV : 0
| Number of MICP components to be considered.
static constexpr int | numBioInWat = enableMICP ? 3 : 0
| Number of biocomponents in the water phase.
static constexpr int | numEq
| The number of equations.
static constexpr int | waterSwitchIdx = -10000
| Index of the switching variable which determines the composistion of the water phase.
static constexpr int | pressureSwitchIdx = PVOffset + 0
| Index of the switching variable which determines the pressure.
static constexpr int | compositionSwitchIdx = -10000
| Index of the switching variable which determines the composition of the hydrocarbon phases.
static constexpr int | solventSaturationIdx
| Index of the primary variable for the first solvent.
static constexpr int | zFractionIdx
| Index of the primary variable for the first extbo component.
static constexpr int | polymerConcentrationIdx
| Index of the primary variable for the first polymer.
static constexpr int | polymerMoleWeightIdx
| Index of the primary variable for the second polymer primary variable (molecular weight).
static constexpr int | microbialConcentrationIdx
| Index of the primary variable for the first MICP component.
static constexpr int | oxygenConcentrationIdx
| Index of the primary variable for the second MICP component.
static constexpr int | ureaConcentrationIdx
| Index of the primary variable for the third MICP component.
static constexpr int | biofilmVolumeFractionIdx
| Index of the primary variable for the fourth MICP component.
static constexpr int | calciteVolumeFractionIdx
| Index of the primary variable for the fifth MICP component.
static constexpr int | foamConcentrationIdx
| Index of the primary variable for the foam.
static constexpr int | saltConcentrationIdx
| Index of the primary variable for the salt.
static constexpr int | temperatureIdx
| Index of the primary variable for temperature.
static constexpr int | conti0EqIdx = PVOffset + 0
| Index of the continuity equation of the first (and only) phase.
static constexpr int | contiSolventEqIdx
| Index of the continuity equation for the first solvent component.
static constexpr int | contiZfracEqIdx
| Index of the continuity equation for the first extbo component.
static constexpr int | contiPolymerEqIdx
| Index of the continuity equation for the first polymer component.
static constexpr int | contiPolymerMWEqIdx
| Index of the continuity equation for the second polymer component (molecular weight).
static constexpr int | contiMicrobialEqIdx
| Index of the continuity equation for the first MICP component.
static constexpr int | contiOxygenEqIdx
| Index of the continuity equation for the second MICP component.
static constexpr int | contiUreaEqIdx
| Index of the continuity equation for the third MICP component.
static constexpr int | contiBiofilmEqIdx
| Index of the continuity equation for the fourth MICP component.
static constexpr int | contiCalciteEqIdx
| Index of the continuity equation for the fifth MICP component.
static constexpr int | contiFoamEqIdx
| Index of the continuity equation for the foam component.
static constexpr int | contiBrineEqIdx
| Index of the continuity equation for the salt component.
static constexpr int | contiEnergyEqIdx
| Index of the continuity equation for energy.

## Detailed Description

template<unsigned numSolventsV, unsigned numExtbosV, unsigned numPolymersV, unsigned numEnergyV, bool enableFoam, bool enableBrine, unsigned PVOffset, unsigned canonicalCompIdx, unsigned numBioCompV>
struct Opm::Opm::BlackOilOnePhaseIndices< numSolventsV, numExtbosV, numPolymersV, numEnergyV, enableFoam, enableBrine, PVOffset, canonicalCompIdx, numBioCompV >

The primary variable and equation indices for the black-oil model.

## Member Data Documentation

## biofilmVolumeFractionIdx

template<unsigned numSolventsV, unsigned numExtbosV, unsigned numPolymersV, unsigned numEnergyV, bool enableFoam, bool enableBrine, unsigned PVOffset, unsigned canonicalCompIdx, unsigned numBioCompV>

constexpr int Opm::Opm::BlackOilOnePhaseIndices< numSolventsV, numExtbosV, numPolymersV, numEnergyV, enableFoam, enableBrine, PVOffset, canonicalCompIdx, numBioCompV >::biofilmVolumeFractionIdx

static constexpr

Initial value:
=
numMICPs > 3 ? ureaConcentrationIdx + 1 : -1000
Opm::BlackOilOnePhaseIndices::ureaConcentrationIdx
static constexpr int ureaConcentrationIdx
Index of the primary variable for the third MICP component.
Definition blackoilonephaseindices.hh:162
Opm::BlackOilOnePhaseIndices::numMICPs
static constexpr int numMICPs
Number of MICP components to be considered.
Definition blackoilonephaseindices.hh:98

Index of the primary variable for the fourth MICP component.

## calciteVolumeFractionIdx

template<unsigned numSolventsV, unsigned numExtbosV, unsigned numPolymersV, unsigned numEnergyV, bool enableFoam, bool enableBrine, unsigned PVOffset, unsigned canonicalCompIdx, unsigned numBioCompV>

constexpr int Opm::Opm::BlackOilOnePhaseIndices< numSolventsV, numExtbosV, numPolymersV, numEnergyV, enableFoam, enableBrine, PVOffset, canonicalCompIdx, numBioCompV >::calciteVolumeFractionIdx

static constexpr

Initial value:
=
numMICPs > 4 ? biofilmVolumeFractionIdx + 1 : -1000
Opm::BlackOilOnePhaseIndices::biofilmVolumeFractionIdx
static constexpr int biofilmVolumeFractionIdx
Index of the primary variable for the fourth MICP component.
Definition blackoilonephaseindices.hh:166

Index of the primary variable for the fifth MICP component.

## compositionSwitchIdx

template<unsigned numSolventsV, unsigned numExtbosV, unsigned numPolymersV, unsigned numEnergyV, bool enableFoam, bool enableBrine, unsigned PVOffset, unsigned canonicalCompIdx, unsigned numBioCompV>

constexpr int Opm::Opm::BlackOilOnePhaseIndices< numSolventsV, numExtbosV, numPolymersV, numEnergyV, enableFoam, enableBrine, PVOffset, canonicalCompIdx, numBioCompV >::compositionSwitchIdx = -10000

static constexpr

Index of the switching variable which determines the composition of the hydrocarbon phases.

Note
  For one-phase models this is disabled.

## contiBiofilmEqIdx

template<unsigned numSolventsV, unsigned numExtbosV, unsigned numPolymersV, unsigned numEnergyV, bool enableFoam, bool enableBrine, unsigned PVOffset, unsigned canonicalCompIdx, unsigned numBioCompV>

constexpr int Opm::Opm::BlackOilOnePhaseIndices< numSolventsV, numExtbosV, numPolymersV, numEnergyV, enableFoam, enableBrine, PVOffset, canonicalCompIdx, numBioCompV >::contiBiofilmEqIdx

static constexpr

Initial value:
=
numMICPs > 3 ? contiUreaEqIdx + 1 : -1000
Opm::BlackOilOnePhaseIndices::contiUreaEqIdx
static constexpr int contiUreaEqIdx
Index of the continuity equation for the third MICP component.
Definition blackoilonephaseindices.hh:217

Index of the continuity equation for the fourth MICP component.

## contiBrineEqIdx

template<unsigned numSolventsV, unsigned numExtbosV, unsigned numPolymersV, unsigned numEnergyV, bool enableFoam, bool enableBrine, unsigned PVOffset, unsigned canonicalCompIdx, unsigned numBioCompV>

constexpr int Opm::Opm::BlackOilOnePhaseIndices< numSolventsV, numExtbosV, numPolymersV, numEnergyV, enableFoam, enableBrine, PVOffset, canonicalCompIdx, numBioCompV >::contiBrineEqIdx

static constexpr

Initial value:
=
enableBrine ? PVOffset + numPhases + numSolvents + numExtbos + numPolymers + numMICPs + numFoam : -1000
Opm::BlackOilOnePhaseIndices::numPolymers
static constexpr int numPolymers
Number of polymer components to be considered.
Definition blackoilonephaseindices.hh:83
Opm::BlackOilOnePhaseIndices::numPhases
static constexpr int numPhases
The number of fluid phases.
Definition blackoilonephaseindices.hh:95
Opm::BlackOilOnePhaseIndices::numSolvents
static constexpr int numSolvents
Number of solvent components to be considered.
Definition blackoilonephaseindices.hh:77
Opm::BlackOilOnePhaseIndices::numFoam
static constexpr int numFoam
Number of foam equations to be considered.
Definition blackoilonephaseindices.hh:89
Opm::BlackOilOnePhaseIndices::numExtbos
static constexpr int numExtbos
Number of components to be considered for extbo.
Definition blackoilonephaseindices.hh:80

Index of the continuity equation for the salt component.

## contiCalciteEqIdx

template<unsigned numSolventsV, unsigned numExtbosV, unsigned numPolymersV, unsigned numEnergyV, bool enableFoam, bool enableBrine, unsigned PVOffset, unsigned canonicalCompIdx, unsigned numBioCompV>

constexpr int Opm::Opm::BlackOilOnePhaseIndices< numSolventsV, numExtbosV, numPolymersV, numEnergyV, enableFoam, enableBrine, PVOffset, canonicalCompIdx, numBioCompV >::contiCalciteEqIdx

static constexpr

Initial value:
=
numMICPs > 4 ? contiBiofilmEqIdx + 1 : -1000
Opm::BlackOilOnePhaseIndices::contiBiofilmEqIdx
static constexpr int contiBiofilmEqIdx
Index of the continuity equation for the fourth MICP component.
Definition blackoilonephaseindices.hh:221

Index of the continuity equation for the fifth MICP component.

## contiEnergyEqIdx

template<unsigned numSolventsV, unsigned numExtbosV, unsigned numPolymersV, unsigned numEnergyV, bool enableFoam, bool enableBrine, unsigned PVOffset, unsigned canonicalCompIdx, unsigned numBioCompV>

constexpr int Opm::Opm::BlackOilOnePhaseIndices< numSolventsV, numExtbosV, numPolymersV, numEnergyV, enableFoam, enableBrine, PVOffset, canonicalCompIdx, numBioCompV >::contiEnergyEqIdx

static constexpr

Initial value:
=
enableEnergy ? PVOffset + numPhases + numSolvents + numExtbos + numPolymers + numMICPs + numFoam + numBrine: -1000
Opm::BlackOilOnePhaseIndices::numBrine
static constexpr int numBrine
Number of salt equations to be considered.
Definition blackoilonephaseindices.hh:92
Opm::BlackOilOnePhaseIndices::enableEnergy
static constexpr bool enableEnergy
Shall energy be conserved?
Definition blackoilonephaseindices.hh:68

Index of the continuity equation for energy.

## contiFoamEqIdx

template<unsigned numSolventsV, unsigned numExtbosV, unsigned numPolymersV, unsigned numEnergyV, bool enableFoam, bool enableBrine, unsigned PVOffset, unsigned canonicalCompIdx, unsigned numBioCompV>

constexpr int Opm::Opm::BlackOilOnePhaseIndices< numSolventsV, numExtbosV, numPolymersV, numEnergyV, enableFoam, enableBrine, PVOffset, canonicalCompIdx, numBioCompV >::contiFoamEqIdx

static constexpr

Initial value:
=
enableFoam ? PVOffset + numPhases + numSolvents + numPolymers + numMICPs : -1000

Index of the continuity equation for the foam component.

## contiMicrobialEqIdx

template<unsigned numSolventsV, unsigned numExtbosV, unsigned numPolymersV, unsigned numEnergyV, bool enableFoam, bool enableBrine, unsigned PVOffset, unsigned canonicalCompIdx, unsigned numBioCompV>

constexpr int Opm::Opm::BlackOilOnePhaseIndices< numSolventsV, numExtbosV, numPolymersV, numEnergyV, enableFoam, enableBrine, PVOffset, canonicalCompIdx, numBioCompV >::contiMicrobialEqIdx

static constexpr

Initial value:
=
enableMICP ? PVOffset + numPhases + numSolvents : -1000
Opm::BlackOilOnePhaseIndices::enableMICP
static constexpr bool enableMICP
Is MICP involved? (microbes, oxygen, urea, biofilm, and calcite).
Definition blackoilonephaseindices.hh:71

Index of the continuity equation for the first MICP component.

## contiOxygenEqIdx

template<unsigned numSolventsV, unsigned numExtbosV, unsigned numPolymersV, unsigned numEnergyV, bool enableFoam, bool enableBrine, unsigned PVOffset, unsigned canonicalCompIdx, unsigned numBioCompV>

constexpr int Opm::Opm::BlackOilOnePhaseIndices< numSolventsV, numExtbosV, numPolymersV, numEnergyV, enableFoam, enableBrine, PVOffset, canonicalCompIdx, numBioCompV >::contiOxygenEqIdx

static constexpr

Initial value:
=
numMICPs > 1 ? contiMicrobialEqIdx + 1 : -1000
Opm::BlackOilOnePhaseIndices::contiMicrobialEqIdx
static constexpr int contiMicrobialEqIdx
Index of the continuity equation for the first MICP component.
Definition blackoilonephaseindices.hh:209

Index of the continuity equation for the second MICP component.

## contiPolymerEqIdx

template<unsigned numSolventsV, unsigned numExtbosV, unsigned numPolymersV, unsigned numEnergyV, bool enableFoam, bool enableBrine, unsigned PVOffset, unsigned canonicalCompIdx, unsigned numBioCompV>

constexpr int Opm::Opm::BlackOilOnePhaseIndices< numSolventsV, numExtbosV, numPolymersV, numEnergyV, enableFoam, enableBrine, PVOffset, canonicalCompIdx, numBioCompV >::contiPolymerEqIdx

static constexpr

Initial value:
=
enablePolymer ? PVOffset + numPhases + numSolvents : -1000
Opm::BlackOilOnePhaseIndices::enablePolymer
static constexpr bool enablePolymer
Are polymers involved?
Definition blackoilonephaseindices.hh:65

Index of the continuity equation for the first polymer component.

## contiPolymerMWEqIdx

template<unsigned numSolventsV, unsigned numExtbosV, unsigned numPolymersV, unsigned numEnergyV, bool enableFoam, bool enableBrine, unsigned PVOffset, unsigned canonicalCompIdx, unsigned numBioCompV>

constexpr int Opm::Opm::BlackOilOnePhaseIndices< numSolventsV, numExtbosV, numPolymersV, numEnergyV, enableFoam, enableBrine, PVOffset, canonicalCompIdx, numBioCompV >::contiPolymerMWEqIdx

static constexpr

Initial value:
=
numPolymers > 1 ? contiPolymerEqIdx + 1 : -1000
Opm::BlackOilOnePhaseIndices::contiPolymerEqIdx
static constexpr int contiPolymerEqIdx
Index of the continuity equation for the first polymer component.
Definition blackoilonephaseindices.hh:201

Index of the continuity equation for the second polymer component (molecular weight).

## contiSolventEqIdx

template<unsigned numSolventsV, unsigned numExtbosV, unsigned numPolymersV, unsigned numEnergyV, bool enableFoam, bool enableBrine, unsigned PVOffset, unsigned canonicalCompIdx, unsigned numBioCompV>

constexpr int Opm::Opm::BlackOilOnePhaseIndices< numSolventsV, numExtbosV, numPolymersV, numEnergyV, enableFoam, enableBrine, PVOffset, canonicalCompIdx, numBioCompV >::contiSolventEqIdx

static constexpr

Initial value:
=
enableSolvent ? PVOffset + numPhases : -1000
Opm::BlackOilOnePhaseIndices::enableSolvent
static constexpr bool enableSolvent
Are solvents involved?
Definition blackoilonephaseindices.hh:59

Index of the continuity equation for the first solvent component.

## contiUreaEqIdx

template<unsigned numSolventsV, unsigned numExtbosV, unsigned numPolymersV, unsigned numEnergyV, bool enableFoam, bool enableBrine, unsigned PVOffset, unsigned canonicalCompIdx, unsigned numBioCompV>

constexpr int Opm::Opm::BlackOilOnePhaseIndices< numSolventsV, numExtbosV, numPolymersV, numEnergyV, enableFoam, enableBrine, PVOffset, canonicalCompIdx, numBioCompV >::contiUreaEqIdx

static constexpr

Initial value:
=
numMICPs > 2 ? contiOxygenEqIdx + 1 : -1000
Opm::BlackOilOnePhaseIndices::contiOxygenEqIdx
static constexpr int contiOxygenEqIdx
Index of the continuity equation for the second MICP component.
Definition blackoilonephaseindices.hh:213

Index of the continuity equation for the third MICP component.

## contiZfracEqIdx

template<unsigned numSolventsV, unsigned numExtbosV, unsigned numPolymersV, unsigned numEnergyV, bool enableFoam, bool enableBrine, unsigned PVOffset, unsigned canonicalCompIdx, unsigned numBioCompV>

constexpr int Opm::Opm::BlackOilOnePhaseIndices< numSolventsV, numExtbosV, numPolymersV, numEnergyV, enableFoam, enableBrine, PVOffset, canonicalCompIdx, numBioCompV >::contiZfracEqIdx

static constexpr

Initial value:
=
enableExtbo ? PVOffset + numPhases + numSolvents : -1000
Opm::BlackOilOnePhaseIndices::enableExtbo
static constexpr bool enableExtbo
Is extbo invoked?
Definition blackoilonephaseindices.hh:62

Index of the continuity equation for the first extbo component.

## foamConcentrationIdx

template<unsigned numSolventsV, unsigned numExtbosV, unsigned numPolymersV, unsigned numEnergyV, bool enableFoam, bool enableBrine, unsigned PVOffset, unsigned canonicalCompIdx, unsigned numBioCompV>

constexpr int Opm::Opm::BlackOilOnePhaseIndices< numSolventsV, numExtbosV, numPolymersV, numEnergyV, enableFoam, enableBrine, PVOffset, canonicalCompIdx, numBioCompV >::foamConcentrationIdx

static constexpr

Initial value:
=
enableFoam ? PVOffset + numPhases + numSolvents + numPolymers + numMICPs : -1000

Index of the primary variable for the foam.

## microbialConcentrationIdx

template<unsigned numSolventsV, unsigned numExtbosV, unsigned numPolymersV, unsigned numEnergyV, bool enableFoam, bool enableBrine, unsigned PVOffset, unsigned canonicalCompIdx, unsigned numBioCompV>

constexpr int Opm::Opm::BlackOilOnePhaseIndices< numSolventsV, numExtbosV, numPolymersV, numEnergyV, enableFoam, enableBrine, PVOffset, canonicalCompIdx, numBioCompV >::microbialConcentrationIdx

static constexpr

Initial value:
=
enableMICP ? PVOffset + numPhases + numSolvents : -1000

Index of the primary variable for the first MICP component.

## numEq

template<unsigned numSolventsV, unsigned numExtbosV, unsigned numPolymersV, unsigned numEnergyV, bool enableFoam, bool enableBrine, unsigned PVOffset, unsigned canonicalCompIdx, unsigned numBioCompV>

constexpr int Opm::Opm::BlackOilOnePhaseIndices< numSolventsV, numExtbosV, numPolymersV, numEnergyV, enableFoam, enableBrine, PVOffset, canonicalCompIdx, numBioCompV >::numEq

static constexpr

Initial value:
= numPhases + numSolvents + numExtbos + numPolymers +
numEnergy + numFoam + numBrine + numMICPs
Opm::BlackOilOnePhaseIndices::numEnergy
static constexpr int numEnergy
Number of energy equations to be considered.
Definition blackoilonephaseindices.hh:86

The number of equations.

## oxygenConcentrationIdx

template<unsigned numSolventsV, unsigned numExtbosV, unsigned numPolymersV, unsigned numEnergyV, bool enableFoam, bool enableBrine, unsigned PVOffset, unsigned canonicalCompIdx, unsigned numBioCompV>

constexpr int Opm::Opm::BlackOilOnePhaseIndices< numSolventsV, numExtbosV, numPolymersV, numEnergyV, enableFoam, enableBrine, PVOffset, canonicalCompIdx, numBioCompV >::oxygenConcentrationIdx

static constexpr

Initial value:
=
numMICPs > 1 ? microbialConcentrationIdx + 1 : -1000
Opm::BlackOilOnePhaseIndices::microbialConcentrationIdx
static constexpr int microbialConcentrationIdx
Index of the primary variable for the first MICP component.
Definition blackoilonephaseindices.hh:154

Index of the primary variable for the second MICP component.

## polymerConcentrationIdx

template<unsigned numSolventsV, unsigned numExtbosV, unsigned numPolymersV, unsigned numEnergyV, bool enableFoam, bool enableBrine, unsigned PVOffset, unsigned canonicalCompIdx, unsigned numBioCompV>

constexpr int Opm::Opm::BlackOilOnePhaseIndices< numSolventsV, numExtbosV, numPolymersV, numEnergyV, enableFoam, enableBrine, PVOffset, canonicalCompIdx, numBioCompV >::polymerConcentrationIdx

static constexpr

Initial value:
=
enablePolymer ? PVOffset + numPhases + numSolvents : -1000

Index of the primary variable for the first polymer.

## polymerMoleWeightIdx

template<unsigned numSolventsV, unsigned numExtbosV, unsigned numPolymersV, unsigned numEnergyV, bool enableFoam, bool enableBrine, unsigned PVOffset, unsigned canonicalCompIdx, unsigned numBioCompV>

constexpr int Opm::Opm::BlackOilOnePhaseIndices< numSolventsV, numExtbosV, numPolymersV, numEnergyV, enableFoam, enableBrine, PVOffset, canonicalCompIdx, numBioCompV >::polymerMoleWeightIdx

static constexpr

Initial value:
=
numPolymers > 1 ? polymerConcentrationIdx + 1 : -1000
Opm::BlackOilOnePhaseIndices::polymerConcentrationIdx
static constexpr int polymerConcentrationIdx
Index of the primary variable for the first polymer.
Definition blackoilonephaseindices.hh:146

Index of the primary variable for the second polymer primary variable (molecular weight).

## pressureSwitchIdx

template<unsigned numSolventsV, unsigned numExtbosV, unsigned numPolymersV, unsigned numEnergyV, bool enableFoam, bool enableBrine, unsigned PVOffset, unsigned canonicalCompIdx, unsigned numBioCompV>

constexpr int Opm::Opm::BlackOilOnePhaseIndices< numSolventsV, numExtbosV, numPolymersV, numEnergyV, enableFoam, enableBrine, PVOffset, canonicalCompIdx, numBioCompV >::pressureSwitchIdx = PVOffset + 0

static constexpr

Index of the switching variable which determines the pressure.

Depending on the phases present, this variable is either interpreted as the pressure of the oil phase, gas phase (if no oil) or water phase (if only water)

## saltConcentrationIdx

template<unsigned numSolventsV, unsigned numExtbosV, unsigned numPolymersV, unsigned numEnergyV, bool enableFoam, bool enableBrine, unsigned PVOffset, unsigned canonicalCompIdx, unsigned numBioCompV>

constexpr int Opm::Opm::BlackOilOnePhaseIndices< numSolventsV, numExtbosV, numPolymersV, numEnergyV, enableFoam, enableBrine, PVOffset, canonicalCompIdx, numBioCompV >::saltConcentrationIdx

static constexpr

Initial value:
=
enableBrine ? PVOffset + numPhases + numSolvents + numExtbos + numPolymers + numMICPs + numFoam : -1000

Index of the primary variable for the salt.

## solventSaturationIdx

template<unsigned numSolventsV, unsigned numExtbosV, unsigned numPolymersV, unsigned numEnergyV, bool enableFoam, bool enableBrine, unsigned PVOffset, unsigned canonicalCompIdx, unsigned numBioCompV>

constexpr int Opm::Opm::BlackOilOnePhaseIndices< numSolventsV, numExtbosV, numPolymersV, numEnergyV, enableFoam, enableBrine, PVOffset, canonicalCompIdx, numBioCompV >::solventSaturationIdx

static constexpr

Initial value:
=
enableSolvent ? PVOffset + numPhases : -1000

Index of the primary variable for the first solvent.

## temperatureIdx

template<unsigned numSolventsV, unsigned numExtbosV, unsigned numPolymersV, unsigned numEnergyV, bool enableFoam, bool enableBrine, unsigned PVOffset, unsigned canonicalCompIdx, unsigned numBioCompV>

constexpr int Opm::Opm::BlackOilOnePhaseIndices< numSolventsV, numExtbosV, numPolymersV, numEnergyV, enableFoam, enableBrine, PVOffset, canonicalCompIdx, numBioCompV >::temperatureIdx

static constexpr

Initial value:
=
enableEnergy ? PVOffset + numPhases + numSolvents + numExtbos + numPolymers + numMICPs + numFoam + numBrine: - 1000

Index of the primary variable for temperature.

## ureaConcentrationIdx

template<unsigned numSolventsV, unsigned numExtbosV, unsigned numPolymersV, unsigned numEnergyV, bool enableFoam, bool enableBrine, unsigned PVOffset, unsigned canonicalCompIdx, unsigned numBioCompV>

constexpr int Opm::Opm::BlackOilOnePhaseIndices< numSolventsV, numExtbosV, numPolymersV, numEnergyV, enableFoam, enableBrine, PVOffset, canonicalCompIdx, numBioCompV >::ureaConcentrationIdx

static constexpr

Initial value:
=
numMICPs > 2 ? oxygenConcentrationIdx + 1 : -1000
Opm::BlackOilOnePhaseIndices::oxygenConcentrationIdx
static constexpr int oxygenConcentrationIdx
Index of the primary variable for the second MICP component.
Definition blackoilonephaseindices.hh:158

Index of the primary variable for the third MICP component.

## waterSwitchIdx

template<unsigned numSolventsV, unsigned numExtbosV, unsigned numPolymersV, unsigned numEnergyV, bool enableFoam, bool enableBrine, unsigned PVOffset, unsigned canonicalCompIdx, unsigned numBioCompV>

constexpr int Opm::Opm::BlackOilOnePhaseIndices< numSolventsV, numExtbosV, numPolymersV, numEnergyV, enableFoam, enableBrine, PVOffset, canonicalCompIdx, numBioCompV >::waterSwitchIdx = -10000

static constexpr

Index of the switching variable which determines the composistion of the water phase.

Depending on the phases present, this variable is either interpreted as water saturation or vapporized water in gas phase.

Note
  For one-phase models this is disabled.

## zFractionIdx

template<unsigned numSolventsV, unsigned numExtbosV, unsigned numPolymersV, unsigned numEnergyV, bool enableFoam, bool enableBrine, unsigned PVOffset, unsigned canonicalCompIdx, unsigned numBioCompV>

constexpr int Opm::Opm::BlackOilOnePhaseIndices< numSolventsV, numExtbosV, numPolymersV, numEnergyV, enableFoam, enableBrine, PVOffset, canonicalCompIdx, numBioCompV >::zFractionIdx

static constexpr

Initial value:
=
enableExtbo ? PVOffset + numPhases + numSolvents : -1000

Index of the primary variable for the first extbo component.

The documentation for this struct was generated from the following files:

- opm/simulators/wells/MultisegmentWellAssemble.cpp
- opm/simulators/wells/MultisegmentWellEval.cpp
- opm/simulators/wells/MultisegmentWellPrimaryVariables.cpp
- opm/simulators/wells/MultisegmentWellSegments.cpp
- opm/simulators/wells/StandardWellAssemble.cpp
- opm/simulators/wells/StandardWellConnections.cpp
- opm/simulators/wells/StandardWellEval.cpp
- opm/simulators/wells/StandardWellPrimaryVariables.cpp
- opm/simulators/wells/WellInterfaceIndices.cpp